#include "ps2.h"
#include <p18cxxx.h>
#include "xlcd.h"
#include <spi.h>
#include "sw_uart.h"
#include <delays.h>

#ifndef CONTROLLER_MISSING_STATE
#define CONTROLLER_MISSING_STATE 9
#endif


//#define DEBUG_PRINT_SERIAL
char ran_once = 0;
extern char byte9;
extern char state; // state
extern char prev_state;
char LPISRFLAG;                 		// Flag, set when LP interrupt has been handled
//unsigned int DELAY;						// variable used in Delay() macro
uint8 PS2_ID, MSG;
uint8 PS2_byte1, PS2_byte2, PS2_byte3, PS2_byte4, PS2_byte5, PS2_byte6;
uint8 PS2_prev_byte1, PS2_prev_byte2, PS2_prev_byte3, PS2_prev_byte4, PS2_prev_byte5, PS2_prev_byte6;
char PS2_pressure[12];

char cmd, response;

void ps2_txrx(unsigned char data_out,unsigned char *reg_in);
void ps2_tx(unsigned char data_out);
void ps2_rx(unsigned char *reg_in);
void print_ascii(char t);
void print_ascii_r(char t, char t2);
void set_mode();
extern void display_string(const rom char * text);
extern void display_number(char);

// see errata sheet for explanation of delay
void ps2_txrx(unsigned char data_out,unsigned char *reg_in){
	//PIR1bits.SSPIF = 0;
	data_out = bitrev(data_out);
	SSPBUF = ( data_out );
	while(!SSPSTATbits.BF);
	//delay_uS(10);
	*reg_in = SSPBUF;
	//delay_uS(10);
}
void ps2_tx(unsigned char data_out){				
//	PIR1bits.SSPIF = 0;
	data_out = bitrev(data_out);
	SSPBUF = (data_out);
	while(!SSPSTATbits.BF);
	//delay_uS(10);
}
void ps2_rx(unsigned char *reg_in){				
//	PIR1bits.SSPIF = 0;			
	SSPBUF = 0x00;
	while(!SSPSTATbits.BF);
	//delay_uS(10);
	*reg_in = SSPBUF;
	//delay_uS(10);
}


void PS2_Talk() {
	
	unsigned int pos_temp;
	unsigned char temp;
	char lcdout[8];
	unsigned char temp2 = 0b00000000;
unsigned char temp3 = 0b11111110;
		
		

		pin_ATT = 0;					// pull ATT low to signal gamepad
		ps2_tx(0x01);					// send: 	Start (0x01 LSBF (order flipped in ps2_tx)				
		ps2_txrx(0x42, &PS2_ID.byte);	// send: 	Request Data (0x42 LSBF)						
		ps2_txrx(0x00, &MSG.byte);// receive gamepad ID:	should be '0x5A' for 'ready to send'			
		ps2_rx(&PS2_byte1.byte);			// receive:	1st byte of button states
		ps2_rx(&PS2_byte2.byte);			// receive:	2nd byte of button states	
		ps2_rx(&PS2_byte3.byte);			// receive:	3rd byte of button states	
		ps2_rx(&PS2_byte4.byte);			// receive:	4th byte of button states
		ps2_rx(&PS2_byte5.byte);			// receive:	5th byte of button states
		ps2_rx(&PS2_byte6.byte);			// receive:	6th byte of button states	
		// pin_ATT = 1;
		
		
		// check to see if PS2_ID.byte is 0x41 or 0.  If it's 0x41, we're not in analog mode and not reading button pressures.
		// If it's 0, no controller is connected or noise is causing it to flake out. 

		// Remember, still have to set pin_ATT back to 1 to finish the polling cycle.

		//LATEbits.LATE2 = 0;

		bitrev(PS2_ID.byte); // reverse the bit order first		
		temp = PS2_ID.byte;
		
		//lcd_clear();
		//lcd_gotoxy(1,1);
	//	PS2_ID.byte = 4;
		//display_number(PS2_ID.byte);
		//play_note(MSG.byte,5);
		if (PS2_ID.byte == 0x41) { // controller was just connected or got restarted from noise and needs to be re-configured to 
										// analog and pressure sensing mode.
			pin_ATT = 1; // close previous cycle		
			
			// go in 'escape mode' or 'config mode'
			//01/ff 43/41 00/5a | 01/ff 00/ff
			pin_ATT = 0;
			ps2_txrx(0x01,&response);
			ps2_txrx(0x43, &PS2_ID.byte);
			ps2_txrx(0x00, &MSG.byte);
			ps2_txrx(0x01,&PS2_byte1.byte);
			ps2_txrx(0x00,&PS2_byte2.byte);	
			pin_ATT = 1;
			Delay10TCYx(255); // not sure which delays are necessary
/*
			print_ascii_r(0x01, 0x00);
			print_ascii_r(0x43, PS2_ID.byte);
			print_ascii_r(0x00, MSG.byte);
			print_ascii_r(0x01, PS2_byte1.byte);
			print_ascii_r(0x00, PS2_byte2.byte);		
			WriteUART(0x0D);
*/	
			// turn dual shock mode, or 'analog' mode on
			//	01/ff 44/f3 00/5a | 01/00 03/00 00/00 00/00 00/00 00/00 
			pin_ATT = 0;
			ps2_txrx(0x01,&response);
			ps2_txrx(0x44, &PS2_ID.byte);
			ps2_txrx(0x00, &MSG.byte);
			ps2_txrx(0x01,&PS2_byte1.byte);
			ps2_txrx(0x03,&PS2_byte2.byte);
			ps2_txrx(0x00,&PS2_byte3.byte);
			ps2_txrx(0x00,&PS2_byte4.byte);
			ps2_txrx(0x00,&PS2_byte5.byte);
			ps2_txrx(0x00,&PS2_byte6.byte);		
			pin_ATT = 1;	
			Delay100TCYx(255); // this one has to be at least 10000 clock cycles at 1MHz cycles, or 1e-6 * 1e4 = .01 seconds
/*
			print_ascii_r(0x01, 0x00);
			print_ascii_r(0x44, PS2_ID.byte);
			print_ascii_r(0x00, MSG.byte);
			print_ascii_r(0x01, PS2_byte1.byte);
			print_ascii_r(0x03, PS2_byte2.byte);
			print_ascii_r(0x00, PS2_byte3.byte);
			print_ascii_r(0x00, PS2_byte4.byte);	
			print_ascii_r(0x00, PS2_byte5.byte);
			print_ascii_r(0x00, PS2_byte6.byte);
		WriteUART(0x0D);
	*/
			/*
			// setup motor mapping: not working yet
			// 01/ff 4d/f3 00/5a | 00/00 01/01 ff/ff ff/ff ff/ff ff/ff
			pin_ATT = 0;
			ps2_txrx(0x01,&response);
			ps2_txrx(0x4d, &PS2_ID.byte);
			ps2_txrx(0x00, &MSG.byte);
			ps2_txrx(0x00,&PS2_byte1.byte); // whichever command byte has 00 will be the stop in the 0x42 poll cammand that triggers the smaller motor
			ps2_txrx(0x01,&PS2_byte2.byte);	// applied to larger motor, which can be controlled with an 8 bit speed. smaller motor is just 0xFF for on, otherwise off.
			ps2_txrx(0xff,&PS2_byte3.byte);
			ps2_txrx(0xff,&PS2_byte4.byte);
			ps2_txrx(0xff,&PS2_byte5.byte);
			ps2_txrx(0xff,&PS2_byte6.byte);		
			pin_ATT = 1;
	
			print_ascii_r(0x01, 0x00);
			print_ascii_r(0x4f, PS2_ID.byte);
			print_ascii_r(0x00, MSG.byte);
			print_ascii_r(0x00, PS2_byte1.byte);
			print_ascii_r(0x01, PS2_byte2.byte);
			print_ascii_r(0xff, PS2_byte3.byte);
			print_ascii_r(0xff, PS2_byte4.byte);	
			print_ascii_r(0xff, PS2_byte5.byte);
			print_ascii_r(0xff, PS2_byte6.byte);
			WriteUART(0x0D);
			*/
	
			// request pressure sensing data
			// 01/ff 4f/f3 00/5a | ff/00 ff/00 03/00 00/00 00/00 00/5a 
			pin_ATT = 0;
			ps2_txrx(0x01,&response);
			ps2_txrx(0x4f, &PS2_ID.byte);
			ps2_txrx(0x00, &MSG.byte);
			ps2_txrx(0xff,&PS2_byte1.byte);
			ps2_txrx(0xff,&PS2_byte2.byte);
			ps2_txrx(0x03,&PS2_byte3.byte);
			ps2_txrx(0x00,&PS2_byte4.byte);
			ps2_txrx(0x00,&PS2_byte5.byte);
			ps2_txrx(0x00,&PS2_byte6.byte);		
			pin_ATT = 1;
			Delay10TCYx(255);
/*
			print_ascii_r(0x01, 0x00);
			print_ascii_r(0x4f, PS2_ID.byte);
			print_ascii_r(0x00, MSG.byte);
			print_ascii_r(0xff, PS2_byte1.byte);
			print_ascii_r(0xff, PS2_byte2.byte);
			print_ascii_r(0x03, PS2_byte3.byte);
			print_ascii_r(0x00, PS2_byte4.byte);	
			print_ascii_r(0x00, PS2_byte5.byte);
			print_ascii_r(0x00, PS2_byte6.byte);
			WriteUART(0x0D);
	*/
			// exit escape mode 2nd method by lynxmotion: "CONFIG_MODE_EXIT_DS2_NATIVE" ... using only the first 2 bytes with 0's doesn't work on China knockoffs
			//CMD=01,43,00,00,5A (5A,5A,5A,5A)
			pin_ATT = 0;
			ps2_txrx(0x01,&response);
			ps2_txrx(0x43, &PS2_ID.byte);
			ps2_txrx(0x00, &MSG.byte);
	
			ps2_txrx(0x00,&PS2_byte1.byte);	
			ps2_txrx(0x5A,&PS2_byte2.byte);
			ps2_txrx(0x5A,&PS2_byte3.byte);
			ps2_txrx(0x5A,&PS2_byte4.byte);
			ps2_txrx(0x5A,&PS2_byte5.byte);
			ps2_txrx(0x5A,&PS2_byte6.byte);	
			pin_ATT = 1;
			Delay10TCYx(255);
/*
			print_ascii_r(0x01, 0x00);
			print_ascii_r(0x43, PS2_ID.byte);
			print_ascii_r(0x00, MSG.byte);
	
			print_ascii_r(0x00, PS2_byte1.byte);
			print_ascii_r(0x5A, PS2_byte2.byte);
			print_ascii_r(0x5A, PS2_byte3.byte);
			print_ascii_r(0x5A, PS2_byte4.byte);
			print_ascii_r(0x5A, PS2_byte5.byte);
			print_ascii_r(0x5A, PS2_byte6.byte);		
			WriteUART(0x0D);
*/
//while(1) {
			// poll once for good measure
			pin_ATT = 0;					// pull ATT low to signal gamepad
			ps2_tx(0x01);					// send: 	Start (0x01 LSBF (order flipped in ps2_tx)				
			ps2_txrx(0x42, &PS2_ID.byte);	// send: 	Request Data (0x42 LSBF)						
			ps2_txrx(0x00, &MSG.byte);// receive gamepad ID:	should be '0x5A' for 'ready to send'			
			ps2_rx(&PS2_byte1.byte);			// receive:	1st byte of button states
			ps2_rx(&PS2_byte2.byte);			// receive:	2nd byte of button states	
			ps2_rx(&PS2_byte3.byte);			// receive:	3rd byte of button states	
			ps2_rx(&PS2_byte4.byte);			// receive:	4th byte of button states
			ps2_rx(&PS2_byte5.byte);			// receive:	5th byte of button states
			ps2_rx(&PS2_byte6.byte);			// receive:	6th byte of button states	
	
			ps2_rx(&PS2_pressure[0]);
			ps2_rx(&PS2_pressure[1]);
			ps2_rx(&PS2_pressure[2]);
			ps2_rx(&PS2_pressure[3]);
			ps2_rx(&PS2_pressure[4]);
			ps2_rx(&PS2_pressure[5]);
			ps2_rx(&PS2_pressure[6]);
			ps2_rx(&PS2_pressure[7]);
			ps2_rx(&PS2_pressure[8]);
			ps2_rx(&PS2_pressure[9]);
			ps2_rx(&PS2_pressure[10]);
			ps2_rx(&PS2_pressure[11]);
			pin_ATT = 1;
			Delay10TCYx(255);
/*
			print_ascii_r(0x01, 0x00);
			print_ascii_r(0x42, PS2_ID.byte);
			print_ascii_r(0x00, MSG.byte);
			print_ascii_r(0x00, PS2_byte1.byte);
			print_ascii_r(0x00, PS2_byte2.byte);
			print_ascii_r(0x00, PS2_byte3.byte);
			print_ascii_r(0x00, PS2_byte4.byte);	
			print_ascii_r(0x00, PS2_byte5.byte);
			print_ascii_r(0x00, PS2_byte6.byte);
			print_ascii_r(0x00, PS2_pressure[0]);
			print_ascii_r(0x00, PS2_pressure[1]);
			print_ascii_r(0x00, PS2_pressure[2]);
			print_ascii_r(0x00, PS2_pressure[3]);	
			print_ascii_r(0x00, PS2_pressure[4]);
			print_ascii_r(0x00, PS2_pressure[5]);
			print_ascii_r(0x00, PS2_pressure[6]);
			print_ascii_r(0x00, PS2_pressure[7]);
			print_ascii_r(0x00, PS2_pressure[8]);
			print_ascii_r(0x00, PS2_pressure[9]);	
			print_ascii_r(0x00, PS2_pressure[10]);
			print_ascii_r(0x00, PS2_pressure[11]);
			WriteUART(0x0D);
			Delay1KTCYx(255);
	*/		
			
		}
		
		else if (state != CONTROLLER_MISSING_STATE && PS2_ID.byte == 0xFF) { // no controller connected, post message	
			
			pin_ATT = 1;
			lcd_clear();
			lcd_gotoxy(1,1);
			display_string("no controller");
			lcd_gotoxy(2,1);
			display_string("connected");			
			prev_state = state;			
			state = CONTROLLER_MISSING_STATE;
		}
		else if (state == CONTROLLER_MISSING_STATE && PS2_ID.byte != 0xFF) {
			// return to previous state
			pin_ATT = 1;
			lcd_clear();
			lcd_gotoxy(1,1);
			display_number(prev_state);	
			goto_state(prev_state);
			prev_state = CONTROLLER_MISSING_STATE;
		}		
		else { // everything's normal and we should be receiving pressure data from all but Guitar Hero controllers
			ps2_rx(&PS2_pressure[0]);
			ps2_rx(&PS2_pressure[1]);
			ps2_rx(&PS2_pressure[2]);
			ps2_rx(&PS2_pressure[3]);
			ps2_rx(&PS2_pressure[4]);
			ps2_rx(&PS2_pressure[5]);
			ps2_rx(&PS2_pressure[6]);
			ps2_rx(&PS2_pressure[7]);
			ps2_rx(&PS2_pressure[8]);
			ps2_rx(&PS2_pressure[9]);
			ps2_rx(&PS2_pressure[10]);
			ps2_rx(&PS2_pressure[11]);
			pin_ATT = 1;

	/*		print_ascii_r(0x00, PS2_pressure[0]);
			print_ascii_r(0x00, PS2_pressure[1]);
			print_ascii_r(0x00, PS2_pressure[2]);
			print_ascii_r(0x00, PS2_pressure[3]);	
			print_ascii_r(0x00, PS2_pressure[4]);
			print_ascii_r(0x00, PS2_pressure[5]);
			print_ascii_r(0x00, PS2_pressure[6]);
			print_ascii_r(0x00, PS2_pressure[7]);
			print_ascii_r(0x00, PS2_pressure[8]);
			print_ascii_r(0x00, PS2_pressure[9]);	
			print_ascii_r(0x00, PS2_pressure[10]);
			print_ascii_r(0x00, PS2_pressure[11]);
	*/
		//	Delay1KTCYx(255);
		//	Delay1KTCYx(255);
		}
		
	
	

	
		
	
		
	

#ifdef DEBUG_PRINT_SERIAL
// send out all the bytes via the software serial port:
	
	WriteUART(0x0D);WriteUART(0x0D);
	print_ascii(PS2_ID.byte);
	print_ascii(MSG.byte);
	print_ascii(PS2_byte1.byte);
	print_ascii(PS2_byte2.byte);
	print_ascii(PS2_byte3.byte);
	print_ascii(PS2_byte4.byte);
	print_ascii(PS2_byte5.byte);
	print_ascii(PS2_byte6.byte);
	Delay1KTCYx(255);
	Delay1KTCYx(255);
	Delay1KTCYx(255);
	Delay1KTCYx(255);


#endif
}

void set_mode() {

	/*
	pin_ATT = 0;
	ps2_txrx(0x01,&response);
	ps2_txrx(0x42, &PS2_ID.byte);	// send: 	Request Data (0x42 LSBF)						
	ps2_txrx(0x00, &MSG.byte);		// receive gamepad ID:	should be '0x5A' for 'ready to send'
		
	ps2_rx(&PS2_byte1.byte);			// receive:	1st byte of button states
	ps2_rx(&PS2_byte2.byte);			// receive:	2nd byte of button states	
	ps2_rx(&PS2_byte3.byte);			// receive:	3rd byte of button states	
	ps2_rx(&PS2_byte4.byte);			// receive:	4th byte of button states
	ps2_rx(&PS2_byte5.byte);			// receive:	5th byte of button states
	ps2_rx(&PS2_byte6.byte);			// receive:	6th byte of button states
	
	WriteUART(0x0D);WriteUART(0x0D);
	WriteUART(0x0D);WriteUART(0x0D);
	print_ascii(PS2_ID.byte);
	print_ascii(MSG.byte);
	print_ascii(PS2_byte1.byte);
	print_ascii(PS2_byte2.byte);
	print_ascii(PS2_byte3.byte);
	print_ascii(PS2_byte4.byte);
	print_ascii(PS2_byte5.byte);
	print_ascii(PS2_byte6.byte);
	pin_ATT = 1;
	Delay1KTCYx(255);
	





	while(1) {
	pin_ATT = 0;
	ps2_txrx(0x01,&response);
	ps2_txrx(0x42, &PS2_ID.byte);	// send: 	Request Data (0x42 LSBF)						
	ps2_txrx(0x00, &MSG.byte);		// receive gamepad ID:	should be '0x5A' for 'ready to send'
		
	ps2_rx(&PS2_byte1.byte);			// receive:	1st byte of button states
	ps2_rx(&PS2_byte2.byte);			// receive:	2nd byte of button states	
	ps2_rx(&PS2_byte3.byte);			// receive:	3rd byte of button states	
	ps2_rx(&PS2_byte4.byte);			// receive:	4th byte of button states
	ps2_rx(&PS2_byte5.byte);			// receive:	5th byte of button states
	ps2_rx(&PS2_byte6.byte);			// receive:	6th byte of button states

	ps2_rx(&PS2_byte7.byte);
	ps2_rx(&PS2_byte8.byte);
	ps2_rx(&PS2_byte9.byte);
	ps2_rx(&PS2_byte10.byte);
	ps2_rx(&PS2_byte11.byte);
	ps2_rx(&PS2_byte12.byte);
	ps2_rx(&PS2_byte13.byte);
	ps2_rx(&PS2_byte14.byte);
	ps2_rx(&PS2_byte15.byte);
	ps2_rx(&PS2_byte16.byte);
	ps2_rx(&PS2_byte17.byte);
	ps2_rx(&PS2_byte18.byte);

	
	
	WriteUART(0x0D);
	print_ascii(PS2_ID.byte);
	print_ascii(MSG.byte);
	print_ascii(PS2_byte1.byte);
	print_ascii(PS2_byte2.byte);
	print_ascii(PS2_byte3.byte);
	print_ascii(PS2_byte4.byte);
	print_ascii(PS2_byte5.byte);
	print_ascii(PS2_byte6.byte);
	WriteUART(0x0D);
	print_ascii(PS2_byte7.byte);
	print_ascii(PS2_byte8.byte);	
	print_ascii(PS2_byte9.byte);
	print_ascii(PS2_byte10.byte);
	print_ascii(PS2_byte11.byte);
	print_ascii(PS2_byte12.byte);
	print_ascii(PS2_byte13.byte);
	print_ascii(PS2_byte14.byte);
	print_ascii(PS2_byte15.byte);
	print_ascii(PS2_byte16.byte);
	print_ascii(PS2_byte17.byte);
	print_ascii(PS2_byte18.byte);
	pin_ATT = 1;
	Delay1KTCYx(255);
	
}
	while(1);
	*/
}

void PS2_Init()
{
	
	
	TRISB = 0b11110001; // bit 1 is the SPI clk output.
	// works on both wireless and chinamade
	OpenSPI(SPI_FOSC_16, MODE_11, SMPMID);   //MODE_11 = (CKP, CKE) = (1,0) 
											//CKP=1 (idle clock state is high, active low)  
											//CKE=0	data is read when the clock transitions
											//from active to idle.  This causes the clock
											//to start out going low, and then high mid-cycle.	
	TRISCbits.TRISC7 = 0;			
	pin_ATT				= 1;	

}

void print_ascii_r(char t, char t2) {
	bitrev(t);
	print_ascii(t);
	WriteUART('_');
	print_ascii(t2);
	WriteUART(0x0D);
}

void print_ascii(char t) {
	char tempL, tempH;
	// first reverse the bits:
	t = bitrev(t);
	// get low nibble
	tempL = t & 0b00001111;
	tempH = t >> 4;
	//while(BusyUSART());
	if (tempH == 0b00000000)
		WriteUART('0');
	else if (tempH == 1 )
		WriteUART('1');
	else if (tempH == 2)
		WriteUART('2');
	else if (tempH == 3)
		WriteUART('3');
	else if (tempH == 4)
		WriteUART('4');
	else if (tempH == 5)
		WriteUART('5');
	else if (tempH == 6)
		WriteUART('6');
	else if (tempH == 7)
		WriteUART('7');
	else if (tempH == 8)
		WriteUART('8');
	else if (tempH == 9)
		WriteUART('9');
	else if (tempH == 0b00001010)
		WriteUART('A');
	else if (tempH == 0b00001011)
		WriteUART('B');
	else if (tempH == 0b00001100)
		WriteUART('C');
	else if (tempH == 0b00001101)
		WriteUART('D');
	else if (tempH == 0b00001110)
		WriteUART('E');	
	else if (tempH == 0b00001111)
		WriteUART('F');

	//while(BusyUSART());
	if (tempL == 0b00000000)
		WriteUART('0');
	else if (tempL == 1 )
		WriteUART('1');
	else if (tempL == 2)
		WriteUART('2');
	else if (tempL == 3)
		WriteUART('3');
	else if (tempL == 4)
		WriteUART('4');
	else if (tempL == 5)
		WriteUART('5');
	else if (tempL == 6)
		WriteUART('6');
	else if (tempL == 7)
		WriteUART('7');
	else if (tempL == 8)
		WriteUART('8');
	else if (tempL == 9)
		WriteUART('9');
	else if (tempL == 0b00001010)
		WriteUART('A');
	else if (tempL == 0b00001011)
		WriteUART('B');
	else if (tempL == 0b00001100)
		WriteUART('C');
	else if (tempL == 0b00001101)
		WriteUART('D');
	else if (tempL == 0b00001110)
		WriteUART('E');
	else if (tempL == 0b00001111)
		WriteUART('F');




	//while(BusyUSART());
	//WriteUART(0x0D);
}

