#include <delays.h>  


extern void delay_uS(char);

	
// Delay for: ((((2*FOSC) / (8*baud)) + 1) / 2) - 9 cycles  		
void DelayRXHalfBitUART(void) {
	 delay_uS(1); // not what's required, but not using RX for now
}


//Delay for:  ((((2*FOSC) / (4*baud)) + 1) / 2) - 14 cycles      
void DelayRXBitUART(void) {
	delay_uS(1); // not what's required, but not using RX for now
}

// Delay for: ((((2*FOSC) / (4*baud)) + 1) / 2) - 12 cycles
// not sure if a cycle is a clock cycle or instruction cycle (= 4 clocks)
void DelayTXBitUART(void) {
	// if Fosc = 8MHz, baud = 31250 for MIDI protocol:
	// (16,000,000 / 125,000 + 1) / 2 - 12 = 52
	
	// for Fosc = 4MHz, 38400 baud is ... 12 Nops
	// at 4MHz, each instruction cycle is 1uS,
	// 1/31250 = 3.197e-5, or 32uS (check on scope for
	// 64uS between two up-down transitions... not sure if
	// the cycle is equally up and down.

	// Fosc = 4MHz, 31250 baud is exactly 17 Nops (instruction cycles).
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();

	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();

	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();

	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();

	
}