/* delays.c - various delays that require adjustment for different clocks */

#include "delays.h"
#include <p18cxxx.h>
#include <delays.h>
void delay_uS (char d) { 
	//Delay10TCYx(1); //this is actually somewhere around .8 uS @ 48MHz clock input
	char i;
	for (i=0;i<d;i++) 
		Nop();
		Nop();		
}


// it appears that a clock cycle is really an instruction cycle, so Delay10KTCYx(1200)
// at a 48MHz input yields a second.
void delay_mS (short long d) {
	unsigned char t;
	// so, each d is 1/1200 seconds, need to multiply by 1.2 to make it a ms
	d = (d*1200)/1000;
	
	if (d > 255) {
		while (d > 255) {
				
				Delay10KTCYx(255);
				d -= 255;			
		}		
	}	
	
	t = (char)d;	
	Delay10KTCYx(t);
}

// delay 18 clock cycles
// the spec sheet actually says you're supposed to check to see if the LCD
// is busy, not wait an ambiguous 18 clock cycles.  we'll start off with a 
// 80uS delay
void DelayFor18TCY(void) {
	Delay1KTCYx(10);
}

// delay 15ms
void DelayPORXLCD(void) {
	delay_mS(15); // overhead will make this slightly longer
}

//delay 5ms
void DelayXLCD(void) {
	delay_mS(5); // overhead will make this slightly longer
}