#ifndef _PS2_H_
#define _PS2_H_



/***** Macros *****/
//#define ps2_txrx(data_out,reg_in) SSPBUF = (data_out);while(!SSPSTATbits.BF);reg_in = ~SSPBUF;	
//#define ps2_tx(data_out)		SSPBUF = (data_out);while(!SSPSTATbits.BF);temp = SSPBUF;								
//#define ps2_rx(reg_in)			SSPBUF = 0x22f;	while(!SSPSTATbits.BF);reg_in = ~SSPBUF;

/***** Ports *****/
#define pin_ATT	 		LATBbits.LATB2
									
/***** Buttons *****/
#define PS2_Select		PS2_byte1.bit0
#define PS2_Start		PS2_byte1.bit3
#define PS2_R1			PS2_byte2.bit3
#define PS2_R2			PS2_byte2.bit1
#define PS2_R3			PS2_byte1.bit2
#define PS2_L1			PS2_byte2.bit2
#define PS2_L2			PS2_byte2.bit0
#define PS2_L3			PS2_byte1.bit1
#define PS2_Up			PS2_byte1.bit4
#define PS2_Down		PS2_byte1.bit6
#define PS2_Left		PS2_byte1.bit7
#define PS2_Right		PS2_byte1.bit5
#define PS2_Circle		PS2_byte2.bit5
#define PS2_Square		PS2_byte2.bit7
#define PS2_X			PS2_byte2.bit6
#define PS2_Triangle	PS2_byte2.bit4
#define PS2_RJX			PS2_byte3.byte
#define PS2_RJY			PS2_byte4.byte
#define PS2_LJX			PS2_byte5.byte
#define PS2_LJY			PS2_byte6.byte


#define PS2_prev_Select		PS2_prev_byte1.bit0
#define PS2_prev_Start		PS2_prev_byte1.bit3
#define PS2_prev_R1			PS2_prev_byte2.bit3
#define PS2_prev_R2			PS2_prev_byte2.bit1
#define PS2_prev_R3			PS2_prev_byte1.bit2
#define PS2_prev_L1			PS2_prev_byte2.bit2
#define PS2_prev_L2			PS2_prev_byte2.bit0
#define PS2_prev_L3			PS2_prev_byte1.bit1
#define PS2_prev_Up			PS2_prev_byte1.bit4
#define PS2_prev_Down		PS2_prev_byte1.bit6
#define PS2_prev_Left		PS2_prev_byte1.bit7
#define PS2_prev_Right		PS2_prev_byte1.bit5
#define PS2_prev_Circle		PS2_prev_byte2.bit5
#define PS2_prev_Square		PS2_prev_byte2.bit7
#define PS2_prev_X			PS2_prev_byte2.bit6
#define PS2_prev_Triangle	PS2_prev_byte2.bit4
#define PS2_prev_RJX			PS2_prev_byte3.byte
#define PS2_prev_RJY			PS2_prev_byte4.byte
#define PS2_prev_LJX			PS2_prev_byte5.byte
#define PS2_prev_LJY			PS2_prev_byte6.byte

#define JOY_UP			0x00
#define	JOY_DOWN		0xFF
#define	JOY_LEFT		0x00
#define	JOY_RIGHT		0xFF
#define JOY_NEUTRAL		0x7F	

#endif



#define bitrev(c)	c = (c & 0x0F) << 4 | (c & 0xF0) >> 4; \
					c = (c & 0x33) << 2 | (c & 0xCC) >> 2; \
					c = (c & 0x55) << 1 | (c & 0xAA) >> 1;
					
/***** Types *****/
typedef union {
  struct {
    unsigned bit7:1;
    unsigned bit6:1;
    unsigned bit5:1;
    unsigned bit4:1;
    unsigned bit3:1;
    unsigned bit2:1;
    unsigned bit1:1;
    unsigned bit0:1;
  };
  struct {
    unsigned char byte;
  };
} uint8; 					
					

void PS2_Init(void);
void PS2_Talk(void);
