/* general xlcd helper functions */
#include <p18cxxx.h>
#include "xlcd.h"

const char const LCD_ROW_ADDRESS[] = {0x00,	0x40};

void lcd_clear(void);

void lcd_gotoxy(char, char);

void lcd_define_char (char c, const char *bitmap);




void lcd_clear(void) {
		
	WriteCmdXLCD(LCD_COMMAND_CLEAR);
}

void lcd_define_char (char c, const char *bitmap)			// Define user-defined chars
	{
	char	i;

	WriteCmdXLCD ((0b01000000) | (c << 3));					// Select char to define

	
	for (i = 0; i < 8; i++)
		WriteDataXLCD (*bitmap++);				//	Put in each byte of memory
}


// index starts at 1
void lcd_gotoxy (char row, char col)					// Position cursor
	{



	row = LCD_ROW_ADDRESS[row-1];					// Get address of first byte on desired row
	row += col - 1;

	WriteCmdXLCD (0x80 | row);					// Write new cursor address
}









